﻿#ifndef S_SIF_VERSION_NUM
#define S_SIF_VERSION_NUM

typedef enum OptimizationMode {
	opt_c = 0,
	opt_intr_sse4 = 1,
	opt_auto = 2,
} OptimizationMode;

#define MAX_D_THREAD 32 // Maximum number of decoding threads
#define MAX_SM_THREAD 8 // Maximum number of threads for entropy model
#define MAX_PATH  260 // The lenght of path to statistics file

#ifdef SIF_LIB_C
#if defined (__GNUC__) && !defined (_WIN32) 
//#define Z_CDECL __attribute__((cdecl))
#define DLL_EXPORT_IMPORT(type,arg) __attribute__((visibility("default"))) type arg

#elif  defined (__MINGW32__)||(__MINGW64__)
#define DLL_EXPORT_IMPORT(type,arg) __declspec(dllexport) type __attribute__((cdecl)) arg

#elif  defined (_WIN32)
//#define Z_CDECL __cdecl
#define DLL_EXPORT_IMPORT(type,arg) __declspec(dllexport) type __cdecl arg
#else
//#define Z_CDECL 
#define DLL_EXPORT_IMPORT(type,arg) type arg
#endif
#else
#if defined (__GNUC__) && !defined (_WIN32) 
//#define Z_CDECL __attribute__((cdecl))
#define DLL_EXPORT_IMPORT(type,arg) __attribute__((visibility("default"))) type arg

#elif  defined (__MINGW32__)||(__MINGW64__)
#define DLL_EXPORT_IMPORT(type,arg) __declspec(dllimport) type __attribute__((cdecl)) arg

#elif  defined (_WIN32)
//#define Z_CDECL __cdecl
#define DLL_EXPORT_IMPORT(type,arg) __declspec(dllimport) type __cdecl arg
#else
//#define Z_CDECL 
#define DLL_EXPORT_IMPORT(type,arg) type arg
#endif
#endif


#include <stdint.h>
// Frame header
typedef enum CollorSpaceMode {
	CS_UNKNOWN = 0,
	CS_BT_601 = 1,
	CS_BT_709 = 2,
	CS_RESERVED = 3,
	CS_SMPTE_240 = 4,
	CS_BT_2020 = 5,
	CS_BT_2020_NoConst = 6,
	CS_RGB = 7,
} CollorSpaceMode;

typedef enum VideoTransferFunction {
	VTS_UNKNOWN = 0,
	VTS_BT_709 = 1,
	VTS_BT470M = 2,
	VTS_2020_10 = 3,
	VTS_2020_12 = 4,
	VTS_2084 = 5,
	VTS_HLG = 6,
	VTS_RESERVED = 7,
} VideoTransferFunction;

typedef enum VideoPrimaries {
	VP_Unknown = 0,
	VP_BT709 = 1,
	VP_BT470_2_SysM = 2,
	VP_BT470_2_SysBG = 3,
	VP_BT2020 = 4,
	VP_RESERVED0 = 5,
	VP_RESERVED1 = 6,
	VP_RESERVED2 = 7,
} VideoPrimaries;

typedef enum NominalRange {
	NR_16_235 = 0,
	NR_0_255 = 1
} NominalRange;

typedef enum CollorResolution {
	CR_420 = 0,
	CR_422 = 1,
	CR_444 = 2,
	CR_RESERVED = 3,
} CollorResolution;

typedef enum S_ReferenceMode {
	RM_AddToRefList = 0,
	RM_SetAsCopperFr = 1,
	RM_SetAsSilverFr = 2,
	RM_SetAsGoldenFr = 3,
} S_ReferenceMode;

typedef enum PixelPrecision {
	bit_8 = 0,
	bit_10 = 1,
	bit_12 = 2,
	PP_RESERVED = 3,
} PixelPrecision;

typedef enum EntropyMode {
	tr_1 = 0,
	tr_2 = 1,
	tr_4 = 2,
	tr_8 = 3,
	tr_reserved = 4,
} EntropyMode;

#define SIF_VER_INT_32 (2<<24)+(0<<16)+(7<<8)+(0)
#define TekNomVers 1601 // Current version number to check previous settings correctnession
#define VERSION_STR "SIF-1 v2.07.0" // Codec version message
#define LVERSION_STR L"SIF-1 v2.07.0" // Codec version message
#define SIF_FILTR_NAME_L  L"SIF-1 Decoder Filter v.2.07.0"

#endif 